#!/usr/bin/env python

def itermerge(seq1, seq2):

    "Merge 'seq1' and 'seq2' to produce an ordered, combined list of results."

    results = []

    iter1 = iter(seq1)
    iter2 = iter(seq2)

    t1 = None
    t2 = None

    t1 = _itermerge_next(iter1)
    if t1 is None:
        _itermerge_fill(iter2, results)
        return results

    while 1:
        if t1 is None:
            t1 = _itermerge_next(iter1)
            if t1 is None:
                results.append(t2)
                _itermerge_fill(iter2, results)
                return results
        else:
            t2 = _itermerge_next(iter2)
            if t2 is None:
                results.append(t1)
                _itermerge_fill(iter1, results)
                return results

        if t1 < t2:
            results.append(t1)
            t1 = None
        else:
            results.append(t2)
            t2 = None

def _itermerge_next(iter):
    try:
        return iter.next()
    except StopIteration:
        return None

def _itermerge_fill(iter, results):
    try:
        while 1:
            results.append(iter.next())
    except StopIteration:
        pass

# vim: tabstop=4 expandtab shiftwidth=4
